from ChildProject.projects import ChildProject
from ChildProject.annotations import AnnotationManager
from ChildProject.pipelines.metrics import Metrics

from functools import partial

import pandas as pd
import numpy as np

METRICS = np.array(
            [["voc_speaker_ph",'vtc','FEM',pd.NA],
             ["voc_speaker_ph",'vtc','MAL',pd.NA],
             ["voc_speaker_ph",'vtc','OCH',pd.NA],
             ["voc_speaker_ph",'vtc','CHI',pd.NA],
             ["voc_dur_speaker_ph",'vtc','FEM',pd.NA],
             ["voc_dur_speaker_ph",'vtc','MAL',pd.NA],
             ["voc_dur_speaker_ph",'vtc','OCH',pd.NA],
             ["voc_dur_speaker_ph",'vtc','CHI',pd.NA],
             ["avg_voc_dur_speaker",'vtc','FEM',pd.NA],
             ["avg_voc_dur_speaker",'vtc','MAL',pd.NA],
             ["avg_voc_dur_speaker",'vtc','OCH',pd.NA],
             ["avg_voc_dur_speaker",'vtc','CHI',pd.NA],
             ["wc_speaker_ph",'alice','FEM',pd.NA],
             ["wc_speaker_ph",'alice','MAL',pd.NA],
             ["sc_speaker_ph",'alice','FEM',pd.NA],
             ["sc_speaker_ph",'alice','MAL',pd.NA],
             ["pc_speaker_ph",'alice','FEM',pd.NA],
             ["pc_speaker_ph",'alice','MAL',pd.NA],
             ["wc_adu_ph",'alice',pd.NA,pd.NA],
             ["sc_adu_ph",'alice',pd.NA,pd.NA],
             ["pc_adu_ph",'alice',pd.NA,pd.NA],
             ["simple_CTC",'vtc',pd.NA,'simple_CTC'],
             ])
             
METRICS = pd.DataFrame(METRICS, columns=["callable","set","speaker","name"])

project = ChildProject('.')
project.read()

metrics = Metrics(project, METRICS)
df = metrics.extract()

df.to_csv('extra/aclew_metrics.csv', index=False)
